<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- icon-top-onScroll -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top-onScroll -->

    <!-- table announcement -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title>
                  <h1>
                    Announcement
                  </h1>
                </v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_add_announcement = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                      ><v-icon small class="pr-1">mdi-message-plus</v-icon>
                      Add announcement
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    :headers="headers"
                    :items="all_announcement"
                    :search="search"
                  >
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="edit_announcement(item)"
                            color="teal"
                          >
                            mdi-pencil
                          </v-icon>
                        </template>
                        <span>Edit</span>
                      </v-tooltip>
                      &nbsp;&nbsp;
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="delete_announcement(item)"
                            color="error"
                          >
                            mdi-delete
                          </v-icon>
                        </template>
                        <span>Delete</span>
                      </v-tooltip>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table announcement -->

    <!-- dialog_add_announcement -->
    <v-dialog v-model="dialog_add_announcement" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color:white;background:#428bca">
          Add Announcement
        </v-card-title>
        <v-form ref="form_add_announcement">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-textarea
                    class="mb-0 pb-0"
                    outlined
                    dense
                    v-model="form_add_announcement.announce_message"
                    :rules="announcementRules"
                    label="announcement"
                  ></v-textarea>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-checkbox
                    v-model="form_add_announcement.status"
                    label="inUse"
                  ></v-checkbox>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_add" style="color: white;"
            >Cancel</v-btn
          >
          <v-btn color="blue" @click="save_add" style="color: white;"
            >Save</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_announcement -->

    <!-- dialog_edit_announcement -->
    <v-dialog v-model="dialog_edit_announcement" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color:white;background:#428bca">
          Edit Announcement
        </v-card-title>
        <v-form ref="form_edit">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-textarea
                    class="mb-0 pb-0"
                    outlined
                    dense
                    v-model="form_edit_announcement.announce_message"
                    :rules="announcementRules"
                    label="announcement"
                  ></v-textarea>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-checkbox
                    v-model="form_edit_announcement.status"
                    label="inUse"
                  ></v-checkbox>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="red"
            @click="dialog_edit_announcement = false"
            style="color: white;"
            >Cancel
          </v-btn>
          <v-btn color="blue" @click="save_edit" style="color: white;">
            Update
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_edit_announcement -->
  </v-app>
</template>

<script>
export default {
  name: "Announcement",
  data() {
    return {
      fab: false,
      dialog_add_announcement: false,
      dialog_edit_announcement: false,
      dialog_delete_announcement: false,
      dialog_loader: false,
      search: "",
      all_announcement: [],
      headers: [
        {
          text: "Announcement",
          align: "start",
          value: "announce_message",
          sortable: false,
        },
        {
          text: "Status",
          align: "start",
          value: "status",
          sortable: false,
        },

        { text: "Action", value: "actions", sortable: false },
      ],
      form_add_announcement: {
        announce_message: "",
        status: false,
      },
      form_edit_announcement: {
        announce_message: "",
        status: false,
      },
      // rule
      announcementRules: [(v) => !!v || "Please enter Announcement"],
    };
  },
  mounted() {
    this.get_announcement();
  },
  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_announcement() {
      this.dialog_loader = true;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/announcement", {
          params: {
            user_id: this.$cookies.get("info_login").user_id,
          },
        })
        .then((response) => {
          this.dialog_loader = false;
          // console.log("response", response.data.data);
          this.all_announcement = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
        });
    },

    cancel_add() {
      this.dialog_add_announcement = false;
      this.$refs.form_add_announcement.reset();
      this.get_announcement();
    },

    save_add() {
      if (!this.$refs.form_add_announcement.validate()) return;
      this.form_add_announcement["user_id"] = this.$cookies.get("info_login").user_id;
      // console.log(this.form_add_announcement);
      this.dialog_loader = true;
      this.dialog_add_announcement = false;

      this.axios
        .post(
          process.env.VUE_APP_API + "/api/v3/announcement",
          this.form_add_announcement
        )
        .then((response) => {
          this.dialog_loader = false;
          console.log("response", response);
          this.get_announcement();
          this.$refs.form_add_announcement.reset();
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Add Announcement success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
        });
    },

    edit_announcement(item) {
      this.form_edit_announcement = item;
      this.dialog_edit_announcement = true;
    },

    save_edit() {
      if (!this.$refs.form_edit.validate()) return;
      this.form_edit_announcement["user_id"] = this.$cookies.get("info_login").user_id;
      this.dialog_edit_announcement = false;
      // console.log("form_edit_announcement", this.form_edit_announcement);
      this.axios
        .put(
          process.env.VUE_APP_API + "/api/v3/announcement",
          this.form_edit_announcement
        )
        .then((response) => {
          console.log("response", response);
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Edit Announcement success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.get_announcement();
            this.$refs.form_edit_announcement.reset();
          });
        })
        .catch((error) => {
          console.log("error", error);
        });
    },

    delete_announcement(item) {
      // console.log(item);
      this.dialog_delete_announcement = true;
      this.$swal({
        title: "Are you sure?",
        text: "You want to delete this Announcement!",
        icon: "warning",
        allowOutsideClick: false,
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!",
        cancelButtonText: "Cancle",
      }).then((result) => {
        if (result.value) {
          this.axios
            .delete(process.env.VUE_APP_API + "/api/v3/announcement", {
              params: {
                announce_id: item.announce_id,
                user_id: this.$cookies.get("info_login").user_id,
              },
            })
            .then((response) => {
              // console.log(response.data);
              // console.log(response.data.status);
              if (response.data.status == "fail") {
                this.$swal({
                  icon: "error",
                  title: "Error!",
                  text: "Announcement is using.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_announcement();
                });
              } else {
                this.$swal({
                  icon: "success",
                  title: "Success!",
                  text: "Delete Announcement success.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_announcement();
                });
              }
            })
            .catch((error) => {
              console.log("error", error);
            });
        }
      });
    },
  },
};
</script>

<style></style>
